/**************************************************************

matread.c (C-Munipack project)
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/
#define _NO_OLDNAMES

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "comfun.h"
#include "cmpack_common.h"
#include "cmpack_phtfile.h"
#include "cmpack_catfile.h"
#include "matread.h"

void ReadRef(CmpackMatch *lc, CmpackPhtFile *pht)
{
	int	i, j, count;
	double x, y;

	j = 0;
	count = cmpack_pht_nstar(pht);
	if (count>0) {
		lc->x1 = (double*) cmpack_realloc(lc->x1, count*sizeof(double));
		lc->y1 = (double*) cmpack_realloc(lc->y1, count*sizeof(double));
		for (i=0; i<count; i++) {
			CmpackPhtStar *star = cmpack_pht_get_star(pht, i);
			if (cmpack_pht_star_get_center(star, &x, &y)) {
				lc->x1[j] = x;
				lc->y1[j] = y;
				j++;
			}
			cmpack_unref(star);
		}
	}
	/* Normal return */
	lc->c1 = j;
}

void ReadCat(CmpackMatch *lc, CmpackCatFile *cat)
{
	int	i, j, count;
	double x, y;

	j = 0;
	count = cmpack_cat_nstar(cat);
	if (count>0) {
		lc->x1 = (double*) cmpack_realloc(lc->x1, count*sizeof(double));
		lc->y1 = (double*) cmpack_realloc(lc->y1, count*sizeof(double));
		for (i=0; i<count; i++) {
			CmpackCatStar *star = cmpack_cat_get_star(cat, i);
			if (cmpack_cat_star_get_center(star, &x, &y)) {
				lc->x1[j] = x;
				lc->y1[j] = y;
				j++;
			}
			cmpack_unref(star);
		}
	}
	/* Normal return */
	lc->c1 = j;
}

void ReadSrc(CmpackMatchFrame *lc, CmpackPhtFile *pht)
{
	int		i, j, count;
	double	x, y;

	j = 0;
	count = cmpack_pht_nstar(pht);
	if (count>0) {
		lc->i2 = (int*) cmpack_realloc(lc->i2, count*sizeof(int));
		lc->x2 = (double*) cmpack_realloc(lc->x2, count*sizeof(double));
		lc->y2 = (double*) cmpack_realloc(lc->y2, count*sizeof(double));
		for (i=0; i<count; i++) {
			CmpackPhtStar *st = cmpack_pht_get_star(pht, i);
			if (cmpack_pht_star_get_center(st, &x, &y)) {
				lc->x2[j] = x;
				lc->y2[j] = y;
				j++;
			}
			cmpack_unref(st);
		}
	}
	/* Normal return */
	lc->c2 = j;
}
