/**************************************************************

aperture_dlg.h (C-Munipack project)
The 'Choose aperture' dialog
Copyright (C) 2008 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef CMPACK_APERTURE_DLG_H
#define CMPACK_APERTURE_DLG_H

#include <gtk/gtk.h>

#include "popup.h"
#include "graph.h"
#include "graph_data.h"

class CApertureDlg
{
public:
	CApertureDlg(GtkWindow *pParent);
	~CApertureDlg();

	bool Execute();
private:
	GtkWidget		*m_pDlg, *m_AperView, *m_DataView;
	GtkListStore	*m_AperList, *m_DataList;
	CGraph			m_Graph;
	GSList			*m_FileList, *m_ColNames;
	int				m_LastIndex, m_AperId, m_Row, m_Column;
	CGraphData		m_Data;
	CPopupMenu		m_SelectMenu;

	int ProcessFiles(class CProgressDlg *sender);
	void SetAperture(int aper_id);
	void SetData(int column);
	void OnMouseMove(void);
	void OnLButtonClick(const GdkEventButton *event);
	void OnSelectionChanged(GtkTreeSelection *selection);

	static void GraphClick(int message, int wparam, void* lparam, void* cb_data);
	static void MenuClick(int message, int wparam, void* lparam, void* cb_data);
	static int ExecuteProc(class CProgressDlg *sender, void *user_data);
	static gboolean foreach_all_files(GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, GSList **list);
	static void selection_changed(GtkTreeSelection *widget, CApertureDlg *pMe);
	static void col_name_free(char *str, void *data);
};

#endif
