/**************************************************************

config.h (C-Munipack project)
Configuration file interface
Copyright (C) 2008 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef MUNIWIN_CONFIGURATION_H
#define MUNIWIN_CONFIGURATION_H

#include <glib.h>

class CConfig
{
public:
	static void Init(void);
	static void Free(void);
	static void Flush(void);

	static void SetStr(const char *group, const char *key, const char *val);
	static void SetDbl(const char *group, const char *key, const double val);
	static void SetInt(const char *group, const char *key, const int val);
	static void SetBool(const char *group, const char *key, bool val);

	static bool TryGetStr(const char *group, const char *key, char **value);
	static bool TryGetDbl(const char *group, const char *key, double *value);
	static bool TryGetInt(const char *group, const char *key, int *value);
	static bool TryGetBool(const char *group, const char *key, bool *value);

	static char *GetStr(const char *group, const char *key, const char *defval = "");
	static double GetDbl(const char *group, const char *key, double defval = 0.0);
	static int GetInt(const char *group, const char *key, int defval = 0);
	static bool GetBool(const char *group, const char *key, bool defval = false);

private:
	static void Load(void);
	static void Save(void);

	static GKeyFile *ms_KeyFile;
	static bool ms_Modified;
};

#endif
