/**************************************************************

preview_dlg.h (C-Munipack project)
The preview dialog
Copyright (C) 2008 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef CMPACK_SHOWHEADER_DLG_H
#define CMPACK_SHOWHEADER_DLG_H

#include <gtk/gtk.h>

class CShowHeaderDlg
{
public:
	// Constructor
	CShowHeaderDlg(GtkWindow *pParent);

	// Destructor
	virtual ~CShowHeaderDlg();

	// Display dialog
	void Execute(const char *filename);

private:
	GtkWidget		*m_Dlg, *m_View, *m_ScrWnd;
	GtkTreeStore	*m_Data;

	static gint response_dialog(GtkWidget *widget, gint arg1, gpointer data);

	// Load CCD frame header
	bool LoadImageHeader(const char *filename);

	// Load photometry file header
	bool LoadPhotHeader(const char *filename);

	// Load catalogue file header
	bool LoadCatalogHeader(const char *filename);

	// Load table header
	bool LoadTableHeader(const char *filename);

	// Load readall file header
	bool LoadReadallHeader(const char *filename);
};

#endif
